﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Data.Linq;

namespace HeuristicLab.Hive.Server.DataAccess {
  public interface IContextFactory {

    /// <summary>
    /// Uses transaction by default.
    /// The caller of this Method is resposible for disposing the Context!
    /// </summary>
    /// <returns></returns>
    IDisposable GetContext();

    IDisposable GetContext(bool withTransaction);

    DataContext CurrentContext { get; }

    void RollbackTransaction();

    void RemoveContext();

    void RemoveAndCompleteTransaction();
  }
}
